!
subroutine LA52(A, Error)
!      
!declaration
real, intent(inout):: A(:,:)
integer, intent(out):: Error
real, allocatable:: W(:)
real RN, AA, AAA
integer i, j, k, m, n
!begin
  Error=0
  n=size(A,1); RN=float(n)
  allocate(W(n))
  do k=1, n
    AA=A(1,1)
    if (RN+abs(AA)==RN) then
      deallocate(W)
      Error=65; return
    end if
    do j=1, n-1;  W(j)=A(1,j+1); end do
    do i=1, n-1
      AAA=W(i)/AA; A(i,n)=AAA
      do j=i, n-1
        A(i,j)=A(i+1,j+1)-W(j)*AAA
      end do
    end do
    A(n,n)=-1.0/AA
  end do
  do j=1,n
    do i=1,j; A(i,j)=-A(i,j); end do
  end do
  deallocate(W)
  return
end subroutine LA52
